# Configuration file for the Sphinx documentation builder.
#
# For the full list of built-in configuration values, see the documentation:
# https://www.sphinx-doc.org/en/master/usage/configuration.html

# -- Project information -----------------------------------------------------
# https://www.sphinx-doc.org/en/master/usage/configuration.html#project-information

import datetime
import sys
from pathlib import Path

# Patch the path so Sphinx can find the module.
sys.path.insert(0,str(Path('../..').resolve()))


# Configuration
project = 'brickmaster'
author = 'Christopher Gill'
release = '0.6.1'
creation_year = "2023"
# Assemble the copyright
current_year = str(datetime.datetime.now().year)
year_span = (
    current_year if current_year == creation_year else creation_year + " - " + current_year
)
copyright = year_span + " " + author

# -- General configuration ---------------------------------------------------
# https://www.sphinx-doc.org/en/master/usage/configuration.html#general-configuration

extensions = [
    "sphinx.ext.autodoc",
    "sphinx.ext.autosummary"
]

templates_path = ['_templates']
exclude_patterns = []



# -- Options for HTML output -------------------------------------------------
# https://www.sphinx-doc.org/en/master/usage/configuration.html#options-for-html-output

#html_theme = 'alabaster'
#html_static_path = ['_static']
import sphinx_rtd_theme
html_theme = "sphinx_rtd_theme"
html_static_path = ['_static']